var assign_to_depth=function(obj,depth){var rendering_group=SET.rendering_groups[depth];if(rendering_group==undefined)SET.rendering_groups[depth]=[obj];else rendering_group.push(obj)}
var update_groups=function(groups){var obj_update=function(x){if(x!=undefined)x.update()};var obj_is_alive=function(x){if(x==undefined||x.is_dead())return!1;return!0};var obj_draw=function(x){x.draw()};for(var i=groups.length-1;i>=0;i--){var group=groups[i];if(group!=undefined){group.forEach(obj_update);var alive=group.filter(obj_is_alive);alive.forEach(obj_draw);groups[i]=alive}}}
var default_set=function(){var set={};set.pixels_per_square=50;set.half_pixels_per_square=(1.0*set.pixels_per_square)/2;set.height=501;set.width=951;set.gheight=Math.floor(set.height/set.pixels_per_square);set.gwidth=Math.floor(set.width/set.pixels_per_square);set.grid_cache={};set.grid_cache_at=function(gx,gy){var gx_cache=set.grid_cache[gx];if(!gx_cache){gx_cache={};set.grid_cache[gx]=gx_cache}
var gy_cache=gx_cache[gy];if(!gy_cache){gy_cache={};gx_cache[gy]=gy_cache}
return gy_cache}
set.grid_cache_reset_all_values_for_key=function(key){for(var gx in set.grid_cache){for(var gy in set.grid_cache[gx]){delete set.grid_cache[gx][gy][key]}}}
set.bg_colors={neutral:color(183,203,226),positive:color(24,210,186),negative:color(244,91,147)};set.bg_color=set.bg_colors.neutral;set.grid_color=color(244,244,244);set.entrance_color=color(180,144,245);set.exit_color=color(255,191,0);set.killzone_color=color(255,56,96,0.6);set.creep_color=color(255,26,79);set.rendering_groups=[];for(var i=0;i<=7;i++)set.rendering_groups.push([]);set.system_render_level=7;set.square_render_level=6;set.killzone_render_level=5;set.grid_render_level=4;set.tower_render_level=3;set.build_zone_render_level=2;set.creep_render_level=1;set.bullet_render_level=0;set.state=undefined;set.creep_variety="Blobs Incoming!";set.creep_size=10;set.creep_hp=5;set.creep_value=0;set.creep_speed=50;set.missile_blast_radius=3.5;set.missile_damage=100;set.gold=100;set.creeps_spawned=0;set.max_creeps=1;set.score=0;set.lives=50;set.nukes=3;set.bomb_cost=50;set.framerate=60;set.kills=0;return set};var SET;var fetch_ui_widgets=function(){var w={};w.score=document.getElementById("score");w.kills=document.getElementById("kills");w.gold=document.getElementById("gold");w.lives=document.getElementById("lives");w.nukes_left=document.getElementById("nukes_left");w.creep_variety=document.getElementById("creep_variety");w.creep_speed=document.getElementById("creep_speed");w.wave=document.getElementById("wave");w.till_next_wave=document.getElementById("till_next_wave");w.bomb_cost=document.getElementById("bomb_cost");w.framerate=document.getElementById("framerate");w.tower=document.getElementById("tower");w.tower_type=document.getElementById("tower_type");w.tower_range=document.getElementById("tower_range");w.tower_damage=document.getElementById("tower_damage");w.tower_rate=document.getElementById("tower_rate");w.tower_upgrade_button=document.getElementById("tower_upgrade_button");w.tower_sell_button=document.getElementById("tower_sell_button");w.creep=document.getElementById("creep");w.creep_type=document.getElementById("creep_type");w.creep_hp=document.getElementById("creep_hp");w.creep_value=document.getElementById("creep_value");w.creep_speed=document.getElementById("creep_speed");return w};var WIDGETS;var InertDrawable=new Object();Object.extend(InertDrawable,{update:function(){},is_dead:function(){return!1},draw:function(){}});var SettingUpdater=function(){var su=new Object();Object.extend(su,InertDrawable);su.update=function(){SET.now=millis()}
assign_to_depth(su,SET.system_render_level);return su};var UIUpdater=function(){var uiu=new Object();Object.extend(uiu,InertDrawable);uiu.update=function(){WIDGETS.creep_variety.innerHTML=SET.creep_variety;WIDGETS.score.innerHTML=SET.score;WIDGETS.gold.innerHTML=SET.gold;WIDGETS.kills.innerHTML=SET.kills;WIDGETS.lives.innerHTML=SET.lives;WIDGETS.nukes_left.innerHTML=SET.nukes+" left";WIDGETS.till_next_wave.innerHTML=Math.floor(((SET.creep_wave_controller.last+SET.creep_wave_controller.delay)-SET.now)/1000)};assign_to_depth(uiu,SET.system_render_level);return uiu}
var Grid=function(){var grid=new Object();Object.extend(grid,InertDrawable);grid.draw=function(){stroke(SET.grid_color);var p=SET.pixels_per_square;var w=SET.width;var h=SET.height;for(i=0;i<w;i+=p){line(i,0,i,h)}
for(i=0;i<h;i+=p){line(0,i,w,i)}};assign_to_depth(grid,SET.grid_render_level);return grid};var GridSquare=function(gx,gy,color){var square=new Object();Object.extend(square,InertDrawable);square.gx=gx;square.gy=gy;square.x=grid_to_pixel(gx);square.y=grid_to_pixel(gy);var mid=center_of_square(gx,gy);square.x_mid=mid.x;square.y_mid=mid.y;return square}
var Square=function(gx,gy,color){var square=GridSquare(gx,gy,color);square.color=color;square.draw=function(){noStroke();fill(this.color);draw_square_in_grid(this.gx,this.gy)}
assign_to_depth(square,SET.square_render_level);return square};var ExitSquare=function(gx,gy){var square=Square(gx,gy,SET.exit_color);square.type="exit";square.draw=function(){noStroke();fill(SET.exit_color);draw_square_in_grid(this.gx,this.gy);noFill();draw_circle_in_grid(this.gx,this.gy)}
return square}
var spawn_wave=function(){if(!SET.state||(SET.state.name()!="GameOverMode"&&SET.state.name()!="PauseMode")){var bonus=Math.floor(((SET.creep_wave_controller.last+SET.creep_wave_controller.delay)-SET.now)/100);SET.creep_wave_controller.spawn_wave(bonus)}}
var nuke_creeps=function(){if(SET.nukes>0){var creeps=SET.rendering_groups[SET.creep_render_level];creeps.forEach(function(x){x.hp=-1;x.value=0});SET.nukes--}
else{error("You're out of nukes!")}};var pause_resume=function(){if(SET.state){var state_name=SET.state.name();if(state_name=="GameOverMode");else if(state_name=="PauseMode"){unselect()}
else{unselect();SET.state=new PauseMode();SET.state.set_up()}}
else{SET.state=new PauseMode();SET.state.set_up()}};var game_lost=function(){unselect();attempt_to_enter_ui_mode(new GameOverMode())}
var generate_map=function(){SET.entrance=Square(0,random(SET.gheight-1),SET.entrance_color);SET.entrance.type="entrance";SET.exit=ExitSquare(SET.gwidth-1,random(SET.gheight-1));populate_terrains()}
var reset_game=function(){SET=default_set();WIDGETS=fetch_ui_widgets();WIDGETS.bomb_cost.innerHTML=SET.bomb_cost;SettingUpdater();UIUpdater();generate_map();SET.creep_wave_controller=CreepWaveController();reset_pathfinding();$('').trigger("game_over",!1)};var on_mouse_moved=function(){if(SET.state&&SET.state.draw){var pos=mouse_pos();SET.state.draw(pos.x,pos.y)}};var UI_MODES_FROM_CLICK=[TowerSelectMode,CreepSelectMode];var on_mouse_press=function(){var pos=mouse_pos();if(SET.state){if(SET.state.is_legal(pos.x,pos.y)){SET.state.action(pos.x,pos.y)}
if(SET.state.can_leave_mode(pos.x,pos.y)){unselect()}}
if(!SET.state){var len=UI_MODES_FROM_CLICK.length;for(var i=0;i<len;i++){var modeFunc=UI_MODES_FROM_CLICK[i];var mode=new modeFunc();if(mode.can_enter_mode(pos.x,pos.y)){SET.state=mode;SET.state.set_up(pos.x,pos.y);break}}}}
var message=function(msg){$('').trigger("message",msg)}
var unselect=function(){if(SET.state)SET.state.tear_down();SET.state=undefined;$('').trigger("no_mode")}
var error=function(msg){$('').trigger("error",msg)}
var start_tower_defense=function(){setup=function(){$('#pause_button').html("Pause");set_canvas("tower_defense");reset_game();size(SET.width,SET.height);frameRate(SET.framerate);mouseMoved(on_mouse_moved);mousePressed(on_mouse_press);initProcessing()}
draw=function(){if(SET.state){var state_name=SET.state.name();if(state_name=="GameOverMode"||state_name=="PauseMode")return}
background(SET.bg_color);update_groups(SET.rendering_groups)}
setup()}